/*
 * SPDX-License-Identifier: GPL-3.0-only
 * MuseScore-CLA-applies
 *
 * MuseScore
 * Music Composition & Notation
 *
 * Copyright (C) 2021 MuseScore BVBA and others
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef MU_FRAMEWORK_MUVERSION_H
#define MU_FRAMEWORK_MUVERSION_H

#include <string>

namespace mu::framework {
class MUVersion
{
public:
    static bool unstable();
    static std::string version();
    static std::string fullVersion();  // e.g. 3.4.0-Beta
    static std::string revision();

    static int majorVersion();
    static int minorVersion();
    static int patchVersion();
};
}

#endif // MU_FRAMEWORK_MUVERSION_H
